module ExchangeOrder (RXCLK, RXDV, DATAIN, VALID, DATAOUT, RESET) ;

input RXCLK ;
input [3:0] DATAIN;
input RXDV;
output VALID;
output [3:0] DATAOUT;
input RESET;

reg [3:0] DATAOUT;
reg [3:0] temp;
reg state;
reg VALID;
reg extraCycle;

always@(posedge RXCLK) begin

	if(RESET) begin
		state <= 0;
		VALID <= 0;
		extraCycle <= 0;
	end

	else 
	case(state) 
	
	0: begin
		temp <= DATAIN;
		DATAOUT <= temp;
		if(RXDV == 1) begin
		 state <= 1;
	 	 extraCycle <= 1;
		end
		  else if (extraCycle == 1) extraCycle <= 0;
		else VALID <= 0;
	   end	
	
	1: begin
		DATAOUT <= DATAIN;
		VALID <= 1;
		state <= 0;
	   end

endcase	

end

endmodule 
