module simpleCRC (RXCLK, DIN, INCOMING, CRCOUT, VALIDCRC) ;

input RXCLK ;
input INCOMING;
input [3:0] DIN;
output [31:0] CRCOUT;
output VALIDCRC;

reg [31:0] CRCOUT;
reg [31:0] newCRC;

assign VALIDCRC = (CRCOUT == 'hdebb20e3) ? 1 : 0;

always @(posedge RXCLK) begin

	if(INCOMING == 0) begin
		CRCOUT <= 'hffffffff;
	end
	
	else begin

		newCRC = CRCOUT;
		if(DIN[0] ^ newCRC[0]) begin
		 newCRC = newCRC ^ 'hedb88320;
		 newCRC = newCRC >> 1;
		end
		else newCRC = newCRC >> 1;
		

		if(DIN[1] ^ newCRC[1]) begin
		 newCRC = newCRC ^ 'hedb88320;
		 newCRC = newCRC >> 1;
		end
		else newCRC = newCRC >> 1;
		
		if(DIN[2] ^ newCRC[2]) begin
		 newCRC = newCRC ^ 'hedb88320;
		 newCRC = newCRC >> 1;
		end
		else newCRC = newCRC >> 1;
		
		if(DIN[3] ^ newCRC[3]) begin
		 newCRC = newCRC ^ 'hedb88320;
		 newCRC = newCRC >> 1;
		end
		else newCRC = newCRC >> 1;
	
	CRCOUT <= newCRC;

	end
end

// add your declarations here

// add your code here

endmodule 
